sc::SCDimension Class Reference

The SCDimension class is used to determine the size and blocking of matrices. More...

`#include <dim.h>`

Inheritance diagram for sc::SCDimension:
[legend]
Collaboration diagram for sc::SCDimension:
[legend]

## Public Member Functions

| SCDimension (int n, const char *name=0)
| Create a dimension with an optional name. More...
| SCDimension (const Ref< SCBlockInfo > &, const char *name=0)
| SCDimension (int n, int nblocks, const int *blocksizes=0, const char *name=0)
| SCDimension (const Ref< KeyVal > &)
| The KeyVal constructor. More...
| SCDimension (StateIn &s)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
int | equiv (const SCDimension *) const
| Test to see if two dimensions are equivalent.
int | n () const
| Return the dimension.
const char * | name () const
| Return the name of the dimension. More...
Ref< SCBlockInfo > | blocks ()
| Return the blocking information for this dimension.
void | print (std::ostream &o=ExEnv::out0()) const
| Print information about this dimension to o.
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Protected Member Functions

| SCDimension (const char *name=0)
Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...

## Protected Attributes

char * | name_
int | n_
Ref< SCBlockInfo > | blocks_

## Additional Inherited Members

Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)

## Detailed Description

The SCDimension class is used to determine the size and blocking of matrices.

The blocking information is stored by an object of class SCBlockInfo.

## Constructor & Destructor Documentation

sc::SCDimension::SCDimension | ( | int | n,
|  | const char * | name = `0`
| ) |  |

Create a dimension with an optional name.

The name is a copy of the '0' terminated string name.

sc::SCDimension::SCDimension | ( | const Ref< KeyVal > & |  | ) |

The KeyVal constructor.

`n`

  This gives size of the dimension. One of n or blocks is required.

`blocks`

  The block information for the dimension can be given as a SCBlockInfo object. One of n or blocks is required.

## Member Function Documentation

const char* sc::SCDimension::name | ( |  | ) | const

inline

Return the name of the dimension.

If no name was given to the constructor, then return 0.

void sc::SCDimension::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

The documentation for this class was generated from the following file:

- dim.h